clear, clc, close all;

syms x1 x2 y1 y2 a1 a2 a3 a4 t1 t2 h1 h2 h3 h4 h5 h6 h7 h8 h9;


% Affine correspondence
x = [x1; x2]; y = [y1; y2]; A = [a1 a3; a2 a4]; t = [t1;t2];

%Homography
H=[h1,h2,h3;h4,h5,h6;h7,h8,h9]';

%disp(H)

eq_=[h7;h8];

Pts_left=[h7;h8];
Pts_right=[y1;y2]*[h3,h6,h9]*[x1;x2;1.0]-[h1,h4;h2,h5]*[x1;x2];

Aff_left=(h3*x1+h6*x2+h9)*A;
Aff_right=[h1,h4;h2,h5]-y*[h3,h6];

EqPts=simplify(Pts_left==Pts_right);
EqAff=simplify(Aff_left(:)==Aff_right(:));

AllEq=[EqPts;EqAff];

[Mtmp aux] = equationsToMatrix(AllEq,[h1,h2,h3,h4,h5,h6,h7,h8,h9]);


%Mtmp gives the well-known equations we also developed.

syms r1 r2 r3 r4 r5 r6 r7 r8 r9 tx ty tz nx ny nz lambda;

R=[r1,r4,r7;r2,r5,r8;r3,r6,r9];

t=[tx;ty;tz];
n=[nx,ny,nz];

H_dec=(R+t*n);
h_vec=H_dec(:);

Constraints=Mtmp*h_vec;

EqFinal=simplify(Constraints==zeros(6,1));
[M b] = equationsToMatrix(EqFinal,[nx,ny,nz])