function [A]=GetClosestConsistentAffineTransform(affine, F, p1, p2)
	l2=F*[p1;1.0];
	l1=F'*[p2;1.0];


	dx1=[l1(2);-l1(1)];
	dx2=[l2(2);-l2(1)];

	dx1=dx1/norm(dx1);
	dx2=dx2/norm(dx2);


	#Check direction of dir :)
%	if ((dx2'*affine*dx1)<0)
%		dx2=-dx2;
%	end

	beta=sqrt(l2(1)*l2(1)+l2(2)*l2(2))/((-F(1,1)*dx1(2)+F(1,2)*dx1(1))*p2(1)+(-F(2,1)*dx1(2)+F(2,2)*dx1(1))*p2(2)-F(3,1)*dx1(2)+F(3,2)*dx1(1));
	beta=abs(beta);

	beta=1.0/beta;



	n1=[-dx1(2);dx1(1)];
	n2=[-dx2(2);dx2(1)];


	CFS(1,:)=[1,0,0,0,n2(1)*dx1(1),n2(1)*n1(1)];
	CFS(2,:)=[0,1,0,0,n2(1)*dx1(2),n2(1)*n1(2)];
	CFS(3,:)=[0,0,1,0,n2(2)*dx1(1),n2(2)*n1(1)];
	CFS(4,:)=[0,0,0,1,n2(2)*dx1(2),n2(2)*n1(2)];

	CFS(5,:)=[n2(1)*dx1(1),n2(1)*dx1(2),n2(2)*dx1(1),n2(2)*dx1(2),0,0];
	CFS(6,:)=[n2(1)*n1(1),n2(1)*n1(2),n2(2)*n1(1),n2(2)*n1(2),0,0];

	bs1=[affine(1,1);affine(1,2);affine(2,1);affine(2,2);0.0;beta];	
	bs2=[affine(1,1);affine(1,2);affine(2,1);affine(2,2);0.0;-beta];	


	Aest1=inv(CFS)*bs1;
	Aest2=inv(CFS)*bs2;


	A1(1,1)=Aest1(1);
	A1(1,2)=Aest1(2);
	A1(2,1)=Aest1(3);
	A1(2,2)=Aest1(4);	

	A2(1,1)=Aest2(1);
	A2(1,2)=Aest2(2);
	A2(2,1)=Aest2(3);
	A2(2,2)=Aest2(4);



	"err1:"
	norm(A1-affine)

	"err2:"
	norm(A2-affine)

	if ((norm(A1-affine))<(norm(A2-affine)))
		A=A1;
	else
		A=A2;
	endif



end
